package org.pvv.gnapplet;

import android.os.Build;
import android.telephony.TelephonyManager;

/**
 * Handler for info request.
 *
 * @author Håvard Wigtil
 */
public class InfoRequestHandler extends AbstractRequestHandler {

    /** Logger tag. */
    private static final String TAG = "Gnapplet.InfoRequestHandler";

    /** TelephonyManager instance. */
    private TelephonyManager mgr;

    /**
     * Create a new instance.
     *
     * @param request Request object
     * @param mgr TelephonyManager instance, for IMEI
     */
    public InfoRequestHandler(GnbusRequest request, TelephonyManager mgr) {
        super(request, TAG);
        this.mgr = mgr;
    }

    @Override
    public GnbusResponse createResponse() {
        switch (getRequest().getCommand()) {
            case Constants.GNAPPLET_MSG_INFO_ID_REQ:
                String imei = mgr.getDeviceId();
                return GnbusResponse.createInfoResponse(Build.MANUFACTURER, Build.MODEL, imei, Build.VERSION.RELEASE, "");

            default:
                return handleUnsupportedCommand();
        }

    }
}
