package org.pvv.gnapplet;

/**
 * Utilities for testing.
 */
public class TestUtil {

    /**
     * Create a request object.
     * @param type Request type
     * @param command Request command
     * @param data Request data
     * @return Request object
     */
    public static byte[] createRequest(byte type, int command, byte... data)
    {
        byte[] request = new byte[10 + data.length];
        request[0] = Constants.MAGIC_BYTE;
        request[4] = type;

        int size = data.length + 2;

        request[2] = highByte(size);
        request[3] = lowByte(size);

        request[6] = highByte(command);
        request[7] = lowByte(command);

        // Copy data, if any
        System.arraycopy(request, 8, data, 0, data.length);

        byte[] checksum = GnbusProtocolMessage.generateChecksumBytes(request);

        request[request.length -2] = checksum[0];
        request[request.length -1] = checksum[1];

        return request;
    }

    public static byte lowByte(int i) {
        return (byte)(i & 0xff);
    }

    public static byte highByte(int i) {
        return (byte)(i >>> 8);
    }
}
